//----------------------------------------------------------------------------------
//aviutlvOC AiOngF␳
// Copyright (c) 2005,2006  N099
//----------------------------------------------------------------------------------
#include <windows.h>
#include <stdio.h>
#include <mmintrin.h>
#include <malloc.h>
#include <math.h>

#include "filter.h"
#include "util.h"

//---------------------------------------------------------------------
//tB^\̒`
//---------------------------------------------------------------------
#define TRACK_N 4
TCHAR *track_name[] = {"x0", "x1", "NOISE", "ʑ" };
int   track_default[] = { 0, 0, 0, 0 };
int   track_s[] = { -256, -256,   0, -180 };
int   track_e[] = {  256,  256, 128,  180 };
enum  { T_GAIN0, T_GAIN1, T_NOISE, T_PHASE };

#define CHECK_N 3
TCHAR *check_name[] = { "MMX", "UV", "411" };
int    check_default[] = { 1, 1, 1 };
enum { C_MMX, C_UV, C_411 };

FILTER_DLL filter = {
  FILTER_FLAG_EX_INFORMATION, 0,0,
  "AiOF␳2",
  TRACK_N, track_name, track_default, track_s, track_e,
  CHECK_N, check_name, check_default,
  func_proc,
  NULL,
  func_exit,
  NULL, NULL, NULL, NULL, NULL, 0,
  "atv_color2 by N099, ver1.2",
  NULL,  NULL,

};

//---------------------------------------------------------------------
// global
//---------------------------------------------------------------------
short *g_tmp0 = NULL;
short *g_tmp1 = NULL;

//---------------------------------------------------------------------
//     tB^\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
  return &filter;
}

//---------------------------------------------------------------------
// IɌĂ΂֐
//---------------------------------------------------------------------
BOOL func_exit( FILTER *fp )
{
  if(NULL != g_tmp0){
    _aligned_free(g_tmp0);
    g_tmp0 = NULL;
  }
  if(NULL != g_tmp1){
    _aligned_free(g_tmp1);
    g_tmp1 = NULL;
  }

  return TRUE;
}

//---------------------------------------------------------------------
// ̈m
//---------------------------------------------------------------------
size_t malloc_temp(int w)
{
  static int width = -1;
  static size_t size = 0;
  size_t sz;

  if(w < 0){
    return 0;
  }
  
  if(width >= w && g_tmp0 && g_tmp1){
    return size;
  }

  // TCYωꍇÄfree
  func_exit(NULL);

  // MMXp2Cx2ch
  w += w&1;
  sz = (w + 4*GB) * sizeof(short) * 2;
  g_tmp0 = _aligned_malloc(sz, 16);
  g_tmp1 = _aligned_malloc(sz, 16);

  if(NULL == g_tmp0 || NULL == g_tmp1){
    func_exit(NULL);
    return 0;
  }
  
  width = w;
  size = sz;
  
  return size;
}

//---------------------------------------------------------------------
// tB^֐
//---------------------------------------------------------------------
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
  int i = fpip->h;
  size_t sz;
  short *tmp0h, *tmp1h;
  PIXEL_YC *ycp;
  ALIGN(static short cc[8], 16);
  //LARGE_INTEGER st,ed;
  
  //QueryPerformanceCounter(&st);

  // Ɨ̈̊m
  sz = malloc_temp(fpip->w);
  if(!sz){
    return FALSE;
  }

  //Ɨ̈̔
  sz /= 2 * sizeof(short);
  tmp0h = g_tmp0 + sz;
  tmp1h = g_tmp1 + sz;


  //ʑ]̂߂̌WvZ
  make_coeff(cc, fp->track[T_PHASE], fp->check[C_UV]);

  if(fp->check[C_411]){
    //YUV411xɐF𐧌
    if(fp->check[C_MMX]){
      for( ; i>1; i-=2){
        ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;

        unpack_color4(g_tmp0, ycp, fpip->w/2, fpip->max_w);
        
        rot_crcb_mmx(g_tmp0, fpip->w/2 + 2*GB, cc);
        
        phshf_mmx(g_tmp1 + 4*GB, g_tmp0 + 4*GB, fpip->w/2);
        
        add_hb_mmx(g_tmp0 + 4*GB, g_tmp1 + 4*GB, fpip->w/2,
                   fp->track[T_GAIN1], fp->track[T_GAIN0],
                   fp->track[T_NOISE]);

        set_gb4(g_tmp0, fpip->w/2);

        hflpf_mmx(g_tmp1 + 4*GB, g_tmp0 + 4*GB, fpip->w/2);

        rot_crcb_mmx(g_tmp1 + 4*GB, fpip->w/2, &cc[4]);
        
        set_gb4(g_tmp1, fpip->w/2);

        interpolate_color_mmx(g_tmp0 + 4*GB, g_tmp1 + 4*GB, fpip->w/2);

        pack_color4(ycp, g_tmp1 + 4*GB, g_tmp0 + 4*GB, fpip->w/2, fpip->max_w);

      }
      _mm_empty();
    }
    for( ; i>0; --i){
      ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;
    
      unpack_color(g_tmp0, g_tmp1, ycp, fpip->w/2);
      
      rot_crcb(g_tmp0, g_tmp1, fpip->w/2 + 2*GB, cc);
      
      //CopyMemory(g_tmp1, g_tmp0, 2*(fpip->w + 4*GB));
      //CopyMemory(g_tmp1, g_tmp0, 2*(fpip->w + 4*GB));
      
      phshf(tmp0h + GB, g_tmp0 + GB, fpip->w/2);
      phshf(tmp1h + GB, g_tmp1 + GB, fpip->w/2);
      
      add_hb(g_tmp0 + GB, tmp1h + GB, fpip->w/2,
             fp->track[T_GAIN1], fp->track[T_NOISE]);
      add_hb(g_tmp1 + GB, tmp0h + GB, fpip->w/2,
             fp->track[T_GAIN0], fp->track[T_NOISE]);
      
      set_gb(g_tmp0, fpip->w/2);
      set_gb(g_tmp1, fpip->w/2);
      
      hflpf(tmp0h + GB, g_tmp0 + GB, fpip->w/2);
      hflpf(tmp1h + GB, g_tmp1 + GB, fpip->w/2);
      
      rot_crcb(tmp0h + GB, tmp1h + GB, fpip->w/2, &cc[4]);
      
      set_gb(tmp0h, fpip->w/2);
      set_gb(tmp1h, fpip->w/2);
      
      interpolate_color(g_tmp0, tmp0h + GB, fpip->w/2);
      interpolate_color(g_tmp1, tmp1h + GB, fpip->w/2);
      
      pack_color(ycp, g_tmp0, g_tmp1, fpip->w);
    }
  }else{
    //FLPFȂ
    if(fp->check[C_MMX]){
      for( ; i>1; i-=2){
        ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;

        unpack_color4(g_tmp0, ycp, fpip->w/2, fpip->max_w);
        
        rot_crcb_mmx(g_tmp0, fpip->w/2 + 2*GB, cc);
        
        phshf_mmx(g_tmp1 + 4*GB, g_tmp0 + 4*GB, fpip->w/2);
        
        add_hb_mmx(g_tmp0 + 4*GB, g_tmp1 + 4*GB, fpip->w/2,
                   fp->track[T_GAIN1], fp->track[T_GAIN0],
                   fp->track[T_NOISE]);

        rot_crcb_mmx(g_tmp0 + 4*GB, fpip->w/2, &cc[4]);
        
        set_gb4(g_tmp0, fpip->w/2);

        interpolate_color_mmx(g_tmp1 + 4*GB, g_tmp0 + 4*GB, fpip->w/2);

        pack_color4(ycp, g_tmp0 + 4*GB, g_tmp1 + 4*GB, fpip->w/2, fpip->max_w);

      }
      _mm_empty();
    }
    for( ; i>0; --i){
      ycp = fpip->ycp_edit + (fpip->h - i)*fpip->max_w;
    
      unpack_color(g_tmp0, g_tmp1, ycp, fpip->w/2);
      
      rot_crcb(g_tmp0, g_tmp1, fpip->w/2 + 2*GB, cc);
      
      //CopyMemory(g_tmp1, g_tmp0, 2*(fpip->w + 4*GB));
      //CopyMemory(g_tmp1, g_tmp0, 2*(fpip->w + 4*GB));
      
      phshf(tmp0h + GB, g_tmp0 + GB, fpip->w/2);
      phshf(tmp1h + GB, g_tmp1 + GB, fpip->w/2);
      
      add_hb(g_tmp0 + GB, tmp1h + GB, fpip->w/2,
             fp->track[T_GAIN1], fp->track[T_NOISE]);
      add_hb(g_tmp1 + GB, tmp0h + GB, fpip->w/2,
             fp->track[T_GAIN0], fp->track[T_NOISE]);
      
      rot_crcb(g_tmp0 + GB, g_tmp1 + GB, fpip->w/2, &cc[4]);
      
      set_gb(g_tmp0, fpip->w/2);
      set_gb(g_tmp1, fpip->w/2);
      
      interpolate_color(tmp0h, g_tmp0 + GB, fpip->w/2);
      interpolate_color(tmp1h, g_tmp1 + GB, fpip->w/2);
      
      pack_color(ycp, tmp0h, tmp1h, fpip->w);
    }
  }
  
  /*
  QueryPerformanceCounter(&ed);
  if(!fp->exfunc->is_saving(fpip->editp)){
    TCHAR buf[256];
    double d = ed.QuadPart - st.QuadPart;
    sprintf(buf, "%s CLK:%e", filter.name, d);
    SetWindowText(fp->hwnd, buf);
  }*/
  
  
  return TRUE;
}

