//
// util.c
// 낢Ȋ֐ Z
//
// Copyright (c) 2005,2006  N099
//
#include <windows.h>

#define _USE_MATH_DEFINES 
#include <math.h>
#include <mmintrin.h>

#include "filter.h"
#include "util.h"

// tB^
// [ɃK[hoh邱Ƃ
// E`FbN͂ȂĂ悢

// ԑш pi/2tF[YVtgtB^ĩqxgϊj
void phshf(short *dst, const short *src, int n)
{
  int i;
  int tmp;

  for(i=0; i<n; ++i){
    tmp = 1<<14;
    //tmp +=     9 *(src[i+15] - src[i-15]);
    //tmp +=    -2 *(src[i+13] - src[i-13]);
    tmp +=  -281 *(src[i+11] - src[i-11]);
    tmp +=  -930 *(src[i+9]  - src[i-9]);
    tmp += -1455 *(src[i+7]  - src[i-7]);
    tmp +=  -769 *(src[i+5]  - src[i-5]);
    tmp +=  2981 *(src[i+3]  - src[i-3]);
    tmp += 19316 *(src[i+1]  - src[i-1]);
    dst[i] = (short)(tmp >> 15);
  }
}

// n[tohtB^
// 127, 0, -548, 0, 1328, 0, -2986, 0, 10266, 16394 (1<<15)
void hflpf(short *dst, const short *src, int n)
{
  int i;
  int tmp;

  for(i=0; i<n; ++i){
    tmp = 1<<14;
    tmp +=   127 *(src[i-9] + src[i+9]);
    tmp +=  -548 *(src[i-7] + src[i+7]);
    tmp +=  1328 *(src[i-5] + src[i+5]);
    tmp += -2986 *(src[i-3] + src[i+3]);
    tmp += 10266 *(src[i-1] + src[i+1]);
    tmp += 16394 * src[i];
    dst[i] = (short)(tmp >> 15);
  }
}

// ʑ]
void rot_crcb(short *cr_i, short *cb_q, int n, const short c[4])
{
  int j;
  int i,q;

  for(j=0; j<n; ++j){
    i = c[0] * cr_i[j] + c[1] * cb_q[j] + (1<<13);
    q = c[2] * cr_i[j] + c[3] * cb_q[j] + (1<<13);
    cr_i[j] = (short)(i >> 14);
    cb_q[j] = (short)(q >> 14);
  }
}

// ʑ]̌WvZ
void make_coeff(short cc[8], int deg, int uv)
{
  static int degree = 720;
  static int cnv_uv = -1;
  double d,c,s;

  //ݒύX̂ݍXV
  if(degree == deg && uv == cnv_uv)
    return;

  _mm_empty();
  
  d = (deg * M_PI) / 180.0;
  c = cos(d);
  s = sin(d);
  
  if(uv){ //Cr,Cb<->UVlꍇ
    //ϊ
    cc[0] = (short)floor((1.402/1.14) *  c * (1<<14) + 0.5);
    cc[1] = (short)floor((1.772/2.03) * -s * (1<<14) + 0.5);
    cc[2] = (short)floor((1.402/1.14) *  s * (1<<14) + 0.5);
    cc[3] = (short)floor((1.772/2.03) *  c * (1<<14) + 0.5);
    //tϊ
    cc[4] = (short)floor((1.14/1.402) *  c * (1<<14) + 0.5);
    cc[5] = (short)floor((1.14/1.402) *  s * (1<<14) + 0.5);
    cc[6] = (short)floor((2.03/1.772) * -s * (1<<14) + 0.5);
    cc[7] = (short)floor((2.03/1.772) *  c * (1<<14) + 0.5);
  }else{
    //ϊ
    cc[0] = (short)floor( c * (1<<14) + 0.5);
    cc[1] = (short)floor(-s * (1<<14) + 0.5);
    cc[2] = (short)floor( s * (1<<14) + 0.5);
    cc[3] = (short)floor( c * (1<<14) + 0.5);
    //tϊ
    cc[4] = (short)floor( c * (1<<14) + 0.5);
    cc[5] = (short)floor( s * (1<<14) + 0.5);
    cc[6] = (short)floor(-s * (1<<14) + 0.5);
    cc[7] = (short)floor( c * (1<<14) + 0.5);
  }

  cnv_uv = uv;
  degree = deg;
}

// PIXEL_YC ̐FЂƂɓǂݏo YU 2:2
// n : Ƃ̃f[^̉̉f̔
// dst  n + 2*GB ̑傫Ƃ
void unpack_color(short *dst_cr, short *dst_cb, const PIXEL_YC *src, int n)
{
  int i;

  //[
  for(i=0; i<GB; ++i){
    *dst_cb++ = src->cb;
    *dst_cr++ = src->cr;
  }

  //S
  for(i=0; i<n; ++i){
    *dst_cb++ = src->cb;
    *dst_cr++ = src->cr;

    src += 2;
  }

  //E[
  src -= 2;
  for(i=0; i<GB; ++i){
    *dst_cb++ = src->cb;
    *dst_cr++ = src->cr;
  }
}

// YU 4:4 Ƃ PIXEL_YC ɖ߂
// n : Ƃ̃f[^̉̉f
void pack_color(PIXEL_YC *dst, const short *src_cr, const short *src_cb, int n)
{
  int i;

  for(i=0; i<n; ++i){
    dst->cb = src_cb[i];
    dst->cr = src_cr[i];

    ++dst;
  }
}

// FԂileft origin YUV422 -> YUV444j
// n : src ̉f
// src : \[X
// dst : ] f[^ n*2
void interpolate_color(short *dst, const short *src, int n)
{
  int i;

  for(i=0; i<n; ++i){
    dst[2*i] = src[i];
    dst[2*i + 1] = (9*(src[i] + src[i+1]) - (src[i-1] + src[i+2]) + 8) >> 4;
  }
}

// ̃qxgϊ
void add_hb(short *dst, const short *hb, int n, int c, int th)
{
  int i,tmp;
  
  if(th *= 2){ //臒l
    const int th_m = -th;
    for(i=0; i<n; ++i){
      tmp = hb[i];
      if(tmp > 0){
        if(tmp < th){
          tmp *= 2;
          tmp = tmp>th ? tmp-th : 0;
        }
      }else{
        if(tmp > th_m){
          tmp *= 2;
          tmp = tmp<th_m ? tmp-th_m : 0;
        }
      }
      
      tmp *= c;
      tmp += dst[i] * 128;
      tmp += 64;
      dst[i] = (short)(tmp >> 7);
    }
  }else{
    for(i=0; i<n; ++i){
      tmp = hb[i];
      tmp *= c;
      tmp += dst[i] * 128;
      tmp += 64;
      dst[i] = (short)(tmp >> 7);
    }
  }
}

// [ɃK[hohZbg
void set_gb(short *dst, int n)
{
  int i;
  short *src = dst + GB;

  //[
  for(i=GB-1; i>=0; --i){
    *dst++ = *(src + i);
  }

  //E[
  dst = src + n;
  src = dst - 1;
  for(i=0; i<GB; ++i){
    *dst++ = *(src - i);
  }
}

