//
// util.h
// 낢Ȋ֐
//
// Copyright (c) 2005  N099
//

void phshf(short *dst, const short *src, int n);
void hflpf(short *dst, const short *src, int n);

void rot_crcb(short *, short *, int n, const short c[4]);
void make_coeff(short c[8], int deg, int uv);

void unpack_color(short *dst_cr, short *dst_cb, const PIXEL_YC *src, int n);
void pack_color(PIXEL_YC *dst, const short *src_cr, const short *src_cb, int n);

void interpolate_color(short *dst, const short *src, int n);
void add_hb(short *dst, const short *hb, int n, int c, int th);

void set_gb(short *dst, int n);

//MMX
void phshf_mmx(short *dst, const short *src, int n);
void hflpf_mmx(short *dst, const short *src, int n);

void rot_crcb_mmx(short *, int, const short c[4]);

void unpack_color4(short *dst, const PIXEL_YC *src, int n, int s);
void pack_color4(PIXEL_YC *dst, const short *src0, const short *src1, int n, int s);

void interpolate_color_mmx(short *dst, const short *src, int n);
void add_hb_mmx(short *dst, const short *hb, int n, int c0, int c1, int th);

void set_gb4(short *dst, int n);

// ẼK[hoh(pixel)
#define GB 16

// ACgw
#ifdef __GNUC__
#define ALIGN(x, n) x __attribute__ ((aligned (n)))
#else
#define ALIGN(x, n) __declspec(align(n)) x
#endif

