//
// util_mmx.c
// util  MMX 
//
// Copyright (c) 2005,2006  N099
//
#include <windows.h>
#include <mmintrin.h>

#include "filter.h"
#include "util.h"

// tB^
// [ɃK[hoh邱Ƃ
// E`FbN͂ȂĂ悢

// ԑш pi/2tF[YVtgtB^ĩqxgϊj
void phshf_mmx(short *dst, const short *src, int n)
{
  int i;
  ALIGN(static const int rr[2], 16) = { 16384, 16384 };
  //ALIGN(static const short cc0[4], 16) = { -2, 9, -2, 9 };
  ALIGN(static const short cc1[4], 16) = { -930, -281, -930, -281 };
  ALIGN(static const short cc2[4], 16) = { -769, -1455, -769, -1455 };
  ALIGN(static const short cc3[4], 16) = { 19316, 2981, 19316, 2981 };
  __m64 sum0, sum1, src0, src1;
  __m64 r, c0, c1, c2, c3, tmp0;
  
  r = *(__m64 *)rr;
  //c0 = *(__m64 *)cc0;
  c1 = *(__m64 *)cc1;
  c2 = *(__m64 *)cc2;
  c3 = *(__m64 *)cc3;
  
  for(i=0; i<n; ++i){
    sum0 = r;
    sum1 = r;
    //
    /*
    src0 = _mm_subs_pi16(*(__m64 *)(src+60), *(__m64 *)(src-60));
    src1 = _mm_subs_pi16(*(__m64 *)(src+52), *(__m64 *)(src-52));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c0);
    src1 = _mm_madd_pi16(src1, c0);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    */
    //
    src0 = _mm_subs_pi16(*(__m64 *)(src+44), *(__m64 *)(src-44));
    src1 = _mm_subs_pi16(*(__m64 *)(src+36), *(__m64 *)(src-36));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c1);
    src1 = _mm_madd_pi16(src1, c1);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_subs_pi16(*(__m64 *)(src+28), *(__m64 *)(src-28));
    src1 = _mm_subs_pi16(*(__m64 *)(src+20), *(__m64 *)(src-20));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c2);
    src1 = _mm_madd_pi16(src1, c2);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_subs_pi16(*(__m64 *)(src+12), *(__m64 *)(src-12));
    src1 = _mm_subs_pi16(*(__m64 *)(src+4), *(__m64 *)(src-4));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c3);
    src1 = _mm_madd_pi16(src1, c3);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    sum0 = _mm_srai_pi32(sum0, 15);
    sum1 = _mm_srai_pi32(sum1, 15);
    *(__m64 *)dst = _mm_packs_pi32(sum0 ,sum1);

    src += 4;
    dst += 4;
  }
}


 
// n[tohtB^
// 127, 0, -548, 0, 1328, 0, -2986, 0, 10266, 16394 (1<<15)
void hflpf_mmx(short *dst, const short *src, int n)
{
  int i;
  ALIGN(static const int rr[2], 16) = { 16384, 16384 };
  ALIGN(static const short cc0[4], 16) = { -548, 127, -548, 127 };
  ALIGN(static const short cc1[4], 16) = { -2986, 1328, -2986, 1328 };
  ALIGN(static const short cc2[4], 16) = { 16394, 10266, 16394, 10266 };
  __m64 sum0, sum1, src0, src1;
  __m64 r, c0, c1, c2, tmp0;
  
  r = *(__m64 *)rr;
  c0 = *(__m64 *)cc0;
  c1 = *(__m64 *)cc1;
  c2 = *(__m64 *)cc2;
  
  for(i=0; i<n; ++i){
    sum0 = r;
    sum1 = r;
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+36), *(__m64 *)(src-36));
    src1 = _mm_adds_pi16(*(__m64 *)(src+28), *(__m64 *)(src-28));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c0);
    src1 = _mm_madd_pi16(src1, c0);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+20), *(__m64 *)(src-20));
    src1 = _mm_adds_pi16(*(__m64 *)(src+12), *(__m64 *)(src-12));
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c1);
    src1 = _mm_madd_pi16(src1, c1);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    src0 = _mm_adds_pi16(*(__m64 *)(src+4), *(__m64 *)(src-4));
    src1 = *(__m64 *)src;
    tmp0 = _mm_unpackhi_pi16(src1, src0);
    src1 = _mm_unpacklo_pi16(src1, src0);
    tmp0 = _mm_madd_pi16(tmp0, c2);
    src1 = _mm_madd_pi16(src1, c2);
    sum0 = _mm_add_pi32(sum0, src1);
    sum1 = _mm_add_pi32(sum1, tmp0);
    //
    
    sum0 = _mm_srai_pi32(sum0, 15);
    sum1 = _mm_srai_pi32(sum1, 15);
    *(__m64 *)dst = _mm_packs_pi32(sum0 ,sum1);

    src += 4;
    dst += 4;
  }
}

// MMXp̐FpbN@
// 
// Cb00,Cr00,Cb01,Cr01,Cb02,Cr02,Cb03,Cr03 //line0
// Cb10,Cr10,Cb11,Cr11,Cb12,Cr12,Cb13,Cr13 //line1
// pbN
// Cr00,Cb00,Cr10,Cb10,Cr01,Cb01,Cr11,Cb11..
// 2ch x 2line 1lineɃpbN

// ʑ]
void rot_crcb_mmx(short *c, int n, const short cc[4])
{
  int j;
  ALIGN(static const int rr[2], 8) = { 8192, 8192 };

  __m64 c_in, i_c, q_c, r, t0, t1, t2;

  i_c = *(__m64 *)cc;
  q_c = *(__m64 *)cc;
  r   = *(__m64 *)rr;
  i_c = _mm_unpacklo_pi32(i_c, i_c);
  q_c = _mm_unpackhi_pi32(q_c, q_c);

  // i = cc0 * cr + cc1 * cb
  // q = cc2 * cr + cc3 * cb
  
  // i_c (cc1,cc0,cc1,cc0)
  // q_c (cc3,cc2,cc3,cc2)

  //4pixelxɏ
  n *= 4;

  c_in = *(__m64 *)c;
  for(j=0; j<n; j+=4){
    // c_in (cb10,cr10,cb00,cr00)
    
    t0 = _mm_madd_pi16(c_in, i_c);
    t0 = _mm_add_pi32(t0, r);
    t0 = _mm_srai_pi32(t0, 14);
    // t0 (i10, i00)
    
    t1 = _mm_madd_pi16(c_in, q_c);
    t1 = _mm_add_pi32(t1, r);
    t1 = _mm_srai_pi32(t1, 14);
    // t1 (q10, q00)

    c_in = *(__m64 *)(c + j + 4); //ǂ
    
    t2 = _mm_unpackhi_pi32(t0,t1);
    t0 = _mm_unpacklo_pi32(t0,t1);
    // t2 (q10, i10)
    // t0 (q00, i00)
    
    *(__m64 *)(c + j) = _mm_packs_pi32(t0 ,t2);
    // dst (q10,i10,q00,i00)
  }
}

// PIXEL_YC ̐FЂƂɓǂݏo YU 2:2
// n : Ƃ̃f[^̉̉f̔
// dst  4*(n + 2*GB) ̑傫Ƃ
// 2ch x 2line C^[[u
void unpack_color4(short *dst, const PIXEL_YC *src, int n, int s)
{
  int i;
  short cr0,cb0,cr1,cb1;

  //[
  cb0 = src->cb;
  cr0 = src->cr;
  cb1 = (src + s)->cb;
  cr1 = (src + s)->cr;
  for(i=0; i<GB; ++i){
    *dst++ = cr0;
    *dst++ = cb0;
    *dst++ = cr1;
    *dst++ = cb1;
  }
  
  //S
  for(i=0; i<n; ++i){
    cb0 = src->cb;
    cr0 = src->cr;
    cb1 = (src + s)->cb;
    cr1 = (src + s)->cr;
    
    *dst++ = cr0;
    *dst++ = cb0;
    *dst++ = cr1;
    *dst++ = cb1;

    src += 2;
  }

  //E[
  for(i=0; i<GB; ++i){
    *dst++ = cr0;
    *dst++ = cb0;
    *dst++ = cr1;
    *dst++ = cb1;
  }
}

// YU 4:4 Ƃ PIXEL_YC ɖ߂
// n : Ƃ̃f[^̉̉f̔
// src0src1}[WBsrc1ɕ⊮ꂽf[^Ă
void pack_color4(PIXEL_YC *dst, const short *src0, const short *src1, int n, int s)
{
  int i;
  short cr0,cb0,cr1,cb1;

  for(i=0; i<n; ++i){
    cr0 = *src0++;
    cb0 = *src0++;
    cr1 = *src0++;
    cb1 = *src0++;
    
    dst->cb = cb0;
    dst->cr = cr0;
    (dst + s)->cb = cb1;
    (dst + s)->cr = cr1;

    ++dst;

    cr0 = *src1++;
    cb0 = *src1++;
    cr1 = *src1++;
    cb1 = *src1++;
    
    dst->cb = cb0;
    dst->cr = cr0;
    (dst + s)->cb = cb1;
    (dst + s)->cr = cr1;
    
    ++dst;
  }
}

// FԂileft origin YUV422 -> YUV444j
// n : src ̉f
// src : \[X
// dst : ] ⊮ꂽf[^݂̂
void interpolate_color_mmx(short *dst, const short *src, int n)
{
  int i;
  __m64 s0,s1,s2,s3,t0,t1,c0,r0;
  ALIGN(static const int rr[2], 8) = { 8, 8 };
  ALIGN(static const short cc[4], 8) = { 9, -1, 9, -1 };

  r0 = *(__m64 *)rr;
  c0 = *(__m64 *)cc;

  s1 = *(__m64 *)(src - 4);
  s2 = *(__m64 *)src;
  s3 = *(__m64 *)(src + 4);

  for(i=0; i<n; ++i){
    s0 = s1;
    s1 = s2;
    s2 = s3;
    s3 = *(__m64 *)(src + 8);
    
    t0 = _mm_adds_pi16(s1, s2);
    s0 = _mm_adds_pi16(s0, s3);
    t1 = _mm_unpackhi_pi16(t0, s0);
    t0 = _mm_unpacklo_pi16(t0, s0);
    t0 = _mm_madd_pi16(t0, c0);
    t1 = _mm_madd_pi16(t1, c0);
    t0 = _mm_add_pi32(t0, r0);
    t1 = _mm_add_pi32(t1, r0);
    t0 = _mm_srai_pi32(t0, 4);
    t1 = _mm_srai_pi32(t1, 4);

    *(__m64 *)dst = _mm_packs_pi32(t0 ,t1);

    dst += 4;
    src += 4;
  }  
  
}

// ̃qxgϊ
void add_hb_mmx(short *dst, const short *hb, int n, int cc0, int cc1, int th)
{
  int i;
  ALIGN(static const int r[2], 16) = { 64, 64 };
  __m64 d0, h0, h1, h2, h3, c0, c1, r0;

  c0 = _mm_set_pi16((short)cc0, 0, (short)cc0, 0);
  c1 = _mm_set_pi16(0, (short)cc1, 0, (short)cc1);
  r0 = *(__m64 *)r;

  if(th){ //臒l
    __m64 th0, m0, m1;
    
    th0 = _mm_set1_pi16((short)(2 * th));
    h3 = *(__m64 *)hb;
    
    for(i=0; i<n; ++i){
      h0 = h3;

      m0 = _mm_srai_pi16(h0, 15); //m0 }XN

      h1 = _mm_and_si64(h0, m0);    //h1 
      h0 = _mm_andnot_si64(m0, h0); //h0 
      h0 = _mm_sub_pi16(h0, h1);
      
      //
      m1 = _mm_cmpgt_pi16(h0, th0); //h0>th }XN
      h1 = _mm_slli_pi16(h0, 1);
      h1 = _mm_subs_pu16(h1, th0);
      h0 = _mm_and_si64(h0, m1);
      m1 = _mm_andnot_si64(m1, h1);
      h0 = _mm_or_si64(h0, m1);
      
      h1 = _mm_and_si64(h0, m0);    //h1 
      m0 = _mm_andnot_si64(m0, h0); //m0 
      m0 = _mm_sub_pi16(m0, h1);
      
      h1 = h0 = m0; //h0,h1 (c3,c2,c1,c0)
      
      d0 = *(__m64 *)dst;
      h3 = *(__m64 *)(hb  + 4); //[v̕[h
      // h (hb10,hr10,hb00,hr00)
      // d (db10,dr10,db00,dr00)
      
      h0 = _mm_madd_pi16(h0, c0); //h0 (cc0*hb10,cc0*hb00)
      h1 = _mm_madd_pi16(h1, c1); //h1 (cc1*hr10,cc1*hr00)
      
      h0 = _mm_add_pi32(h0, r0);
      h1 = _mm_add_pi32(h1, r0);
      
      h0 = _mm_srai_pi32(h0, 7);
      h1 = _mm_srai_pi32(h1, 7);

      h2 = _mm_unpackhi_pi32(h0,h1); //h2 (cc1*hr10,cc0*hb10)
      h0 = _mm_unpacklo_pi32(h0,h1); //h0 (cc1*hr00,cc0*hb00)
      
      h0 = _mm_packs_pi32(h0, h2); //h0 (hr10,hb10,hr00,hb00)
      
      *(__m64 *)dst = _mm_adds_pi16(d0, h0);
      
      dst += 4;
      hb += 4;
    }
  }else{
    h3 = *(__m64 *)hb;
    
    for(i=0; i<n; ++i){
      h1 = h0 = h3;

      h3 = *(__m64 *)(hb + 4); //[v̕[h
      d0 = *(__m64 *)dst;
      // h (hb10,hr10,hb00,hr00)
      // d (db10,dr10,db00,dr00)
      
      h0 = _mm_madd_pi16(h0, c0); //h0 (cc0*hb10,cc0*hb00)
      h1 = _mm_madd_pi16(h1, c1); //h1 (cc1*hr10,cc1*hr00)
      
      h0 = _mm_add_pi32(h0, r0);
      h1 = _mm_add_pi32(h1, r0);
      
      h0 = _mm_srai_pi32(h0, 7);
      h1 = _mm_srai_pi32(h1, 7);

      h2 = _mm_unpackhi_pi32(h0,h1); //h2 (cc1*hr10,cc0*hb10)
      h0 = _mm_unpacklo_pi32(h0,h1); //h0 (cc1*hr00,cc0*hb00)
      
      h0 = _mm_packs_pi32(h0, h2); //h0 (hr10,hb10,hr00,hb00)
      
      *(__m64 *)dst = _mm_adds_pi16(d0, h0);
      
      dst += 4;
      hb += 4;
    }
  }
}

// [ɃK[hohZbg
void set_gb4(short *dst, int n)
{
  int i;
  __m64 *d = (__m64 *)dst;
  __m64 *s = d + GB;

  //[
  for(i=GB-1; i>=0; --i){
    *d++ = *(s + i);
  }

  //E[
  d = s + n;
  s = d - 1;
  for(i=0; i<GB; ++i){
    *d++ = *(s - i);
  }
}

